%% Load data single benchy
load('Benchy_single.mat')

locs = retractions(e);
for i = 1:length(locs)
    x(locs(i)) = NaN;
    y(locs(i)) = NaN;
    z(locs(i)) = NaN;
    e(locs(i)) = NaN;
    r(locs(i)) = NaN;
end

ts = t;
xs = x;
ys = y;
zs = z;
es = e;
rs = movmean(r,fs/10);

%% Load data multi benchy
load('Benchy_multi.mat')

locs = retractions(e);
for i = 1:length(locs)
    x(locs(i)) = NaN;
    y(locs(i)) = NaN;
    z(locs(i)) = NaN;
    e(locs(i)) = NaN;
    r(locs(i)) = NaN;
end

tm = t;
xm = x;
ym = y;
zm = z;
em = e;
rm = movmean(r,fs/10);

%% Plot xyz
fig1 = figure('units','normalized','outerposition',[0 0 1 1]);
sgtitle('Benchy')
ds = 100;
sa = 12; %label,legend
sb = 18; %titles

tiledlayout(3,5);

ax1 = nexttile();
[y,z]=imread('leftH','jpeg');
imshow(y)
title('(a)','FontSize', sb)
ax1.TitleHorizontalAlignment = 'left'; 

ax2 = nexttile();
[y,z]=imread('frontH','jpeg');
imshow(y)
title('(b)','FontSize', sb)
ax2.TitleHorizontalAlignment = 'left';

ax3 = nexttile();
[y,z]=imread('rightH','jpeg');
imshow(y)
title('(c)','FontSize', sb)
ax3.TitleHorizontalAlignment = 'left';

ax4 = nexttile();
[y,z]=imread('rearH','jpeg');
imshow(y)
title('(d)','FontSize', sb)
ax4.TitleHorizontalAlignment = 'left'; 

ax5 = nexttile();
[y,z]=imread('bottomH','jpeg');
imshow(y)
title('(e)','FontSize', sb)
ax5.TitleHorizontalAlignment = 'left'; 

%% Single
ax6 = nexttile();
scatter3(xs(1:ds:end),ys(1:ds:end),zs(1:ds:end),5,(rs(1:ds:end)), 'filled');
xlabel('X [mm]','FontSize', sa)
ylabel('Y [mm]','FontSize', sa)
zlabel('Z [mm]','FontSize', sa)
axis equal
caxis([0 3000]);
xlim([0 25]);
ylim([0 20]);
view(0,0);
title('(f)','FontSize', sb)
ax6.TitleHorizontalAlignment = 'left'; 

ax7 = nexttile();
scatter3(xs(1:ds:end),ys(1:ds:end),zs(1:ds:end),5,(rs(1:ds:end)), 'filled');
xlabel('X [mm]','FontSize', sa)
ylabel('Y [mm]','FontSize', sa)
zlabel('Z [mm]','FontSize', sa)
axis equal
caxis([0 3000]);
xlim([0 25]);
view(270,0);
title('(g)','FontSize', sb)
ax7.TitleHorizontalAlignment = 'left'; 

ax8 = nexttile();
scatter3(xs(1:ds:end),ys(1:ds:end),zs(1:ds:end),5,(rs(1:ds:end)), 'filled');
xlabel('X [mm]','FontSize', sa)
ylabel('Y [mm]','FontSize', sa)
zlabel('Z [mm]','FontSize', sa)
axis equal
caxis([0 3000]);
xlim([0 25]);
view(180,0);
title('(h)','FontSize', sb)
ax8.TitleHorizontalAlignment = 'left'; 

ax9 = nexttile();
scatter3(xs(1:ds:end),ys(1:ds:end),zs(1:ds:end),5,(rs(1:ds:end)), 'filled');
xlabel('X [mm]','FontSize', sa)
ylabel('Y [mm]','FontSize', sa)
zlabel('Z [mm]','FontSize', sa)
axis equal
caxis([0 3000]);
xlim([0 25]);
view(90,0);
title('(i)','FontSize', sb)
ax9.TitleHorizontalAlignment = 'left'; 

ax10 = nexttile();
scatter3(xs(1:ds:end),ys(1:ds:end),zs(1:ds:end),5,(rs(1:ds:end)), 'filled');
xlabel('X [mm]','FontSize', sa)
ylabel('Y [mm]','FontSize', sa)
zlabel('Z [mm]','FontSize', sa)
axis equal
caxis([0 3000]);
xlim([2.5 27.5]);
ylim([5 21]);
view(180,270);
title('(j)','FontSize', sb)
ax10.TitleHorizontalAlignment = 'left'; 

%% multi
ax11 = nexttile();
scatter3(xm(1:ds:end),ym(1:ds:end),zm(1:ds:end),5,(rm(1:ds:end)), 'filled');
xlabel('X [mm]','FontSize', sa)
ylabel('Y [mm]','FontSize', sa)
zlabel('Z [mm]','FontSize', sa)
axis equal
caxis([0 3000]);
xlim([0 25]);
view(0,0);
title('(k)','FontSize', sb)
ax11.TitleHorizontalAlignment = 'left'; 

ax12 = nexttile();
scatter3(xm(1:ds:end),ym(1:ds:end),zm(1:ds:end),5,(rm(1:ds:end)), 'filled');
xlabel('X [mm]','FontSize', sa)
ylabel('Y [mm]','FontSize', sa)
zlabel('Z [mm]','FontSize', sa)
axis equal
caxis([0 3000]);
view(270,0);
title('(l)','FontSize', sb)
ax12.TitleHorizontalAlignment = 'left'; 

ax13 = nexttile();
scatter3(xm(1:ds:end),ym(1:ds:end),zm(1:ds:end),5,(rm(1:ds:end)), 'filled');
xlabel('X [mm]','FontSize', sa)
ylabel('Y [mm]','FontSize', sa)
zlabel('Z [mm]','FontSize', sa)
axis equal
caxis([0 3000]);
xlim([0 25]);
view(180,0);
title('(m)','FontSize', sb)
ax13.TitleHorizontalAlignment = 'left'; 

ax14 = nexttile();
scatter3(xm(1:ds:end),ym(1:ds:end),zm(1:ds:end),5,(rm(1:ds:end)), 'filled');
xlabel('X [mm]','FontSize', sa)
ylabel('Y [mm]','FontSize', sa)
zlabel('Z [mm]','FontSize', sa)
axis equal
caxis([0 3000]);
view(90,0);
title('(n)','FontSize', sb)
ax14.TitleHorizontalAlignment = 'left'; 

ax15 = nexttile();
scatter3(xm(1:ds:end),ym(1:ds:end),zm(1:ds:end),5,(rm(1:ds:end)), 'filled');
xlabel('X [mm]','FontSize', sa)
ylabel('Y [mm]','FontSize', sa)
zlabel('Z [mm]','FontSize', sa)
axis equal
caxis([0 3000]);
xlim([2.5 27.5]);
ylim([5 21]);
view(180,270);
title('(o)','FontSize', sb)
ax15.TitleHorizontalAlignment = 'left'; 

cb = colorbar;
colormap('turbo');
title(cb, 'R [Ohm]')
cb.Layout.Tile = 'east';

%% Save results
saveas(fig1,'Benchy.svg')
close figure 1
clear all